@themeName: ec-odp-default; // theme Name
// General
@primary-color: #f4f8f9; // Base color for entire theme
@secondary-color: #bdc3c7; // Base color for bar-backgrounds
@text-color: #45474d; // Text color for enabled widgets
@disabled-color: #c0c0c0; // Base for disabled backgrounds and borders
@error-color: #ff0000;

@container-background-color: #ffffff; // Backgrounds for various content areas such as TitlePane, ContentPane and Inputs (if changed, adjust selected tab to match)

@minor-selected-color: @ct-highlight-color; // Color for various arrows and buttons
@base-border-color: @container-background-color; // Augmented and used directly by variables to create border colors for various widgets
@unfocused-clickable-color: spin(
  saturate(darken(@ct-highlight-color, 5), 10),
  0
); // Background color for enabled buttons, text inputs
@border-color: darken(
  @container-background-color,
  10%
); // Border color for (enabled, unhovered) TextBox, Slider, Accordion, BorderContainer, TabContainer
@minor-border-color: @secondary-color; // Color of borders inside widgets: horizontal line in Calendar between weeks, around color swatches in ColorPalette, above Dialog action bar
@popup-border-color: @secondary-color; // Border for Dialog, Menu, Tooltip.   Must also update tooltip.png (the arrow image file) to match

@disabled-border-color: @disabled-color; // Border color for disabled/readonly Button, TextBox etc. widgets
@disabled-background-color: darken(
  @disabled-color,
  10%
); // Disabled button, textbox, etc.
@disabled-text-color: lighten(
  @disabled-color,
  10%
); // Text color for disabled/readonly widgets

@unselected-background-color: @container-background-color; // Background color for unselected/unopened tab button, accordion pane, TitlePane, Menu items
@unselected-text-color: darken(
  @secondary-color,
  65
); // Text color for unselected/unopened tab button, accordion pane, TitlePane, Menu items

@hovered-border-color: @ct-highlight-color; // Hover of textbox, tab label, BorderContainer splitter, Calendar, etc.
@hovered-background-color: @ct-highlight-color; // Background color for hover of Button, MenuBar, Accordion pane, Calendar... anything that has a (non-white) color to start with and gets darker on hover
@hovered-text-color: #ffffff; // Used for title of select Accordion pane, label of select tab, hovered Menu item, etc.

@pressed-border-color: @ct-highlight-color; // During click on Calendar day, Slider up/down buttons, tab button, etc.
@pressed-background-color: @ct-highlight-color; // Background color while clicking on Accordion/TitlePane title bar, tab button, Calendar day, Toolbar button, Tree row.

@selected-border-color: @container-background-color; // Selected AccordionPane, tab of nested TabContainer (but plain TabContainer is special)
@selected-background-color: @container-background-color; // Selected Accordion pane, nested tab label, Tree row
@selected-text-color: @ct-highlight-text-color; // title of selected Accordion pane, label of selected tab, hovered Menu item, etc.

@bar-background-color: darken(
  @container-background-color,
  5%
); // MenuBar, Toolbar, action bar at bottom of dialog
@pane-background-color: @container-background-color; // Background color of  Accordion panes, Dialogs, etc.
@popup-background-color: @container-background-color; // Background for Dialog.   TODO: currently use for ColorPalette, maybe should change.

// Buttons
@button-border-color: @button-background-color; // Border for (stand-alone) buttons in normal, hovered, or active state
@button-background-color: @ct-primary-button-color; // Background color for (unhovered) buttons
@button-hovered-background-color: desaturate(
  lighten(@ct-primary-button-color, 10%),
  5%
); // Background color for hovered buttons
@button-pressed-background-color: darken(
  @ct-primary-button-color,
  10%
); // Background color for active buttons
@button-border-radius: 0; //TODO: incooperate in Button.less  and where it should be needed...                                                  // Rounded corner radius for buttons (except in toolbar)

// Input widgets
@focused-border-color: lighten(
  @ct-highlight-color,
  10%
); // Focused textbox, editor, select, etc.
@error-border-color: @error-color; // Border for textbox in error state
@error-focused-border-color: darken(
  @error-color,
  5
); // Border of textbox in error state, and focused
@erroricon-background-color: @error-color;

// Background color for exclamation point validation icon (for TextBox in error state)
@textbox-background-color: #fff; //@container-background-color;			// Default background color of TextBox based widgets
@textbox-hovered-background-color: @textbox-background-color; // Background color when hovering a unfocused TextBox, Select, Editor, or other input widget
@textbox-focused-background-color: @textbox-background-color;
@textbox-error-background-color: @textbox-background-color;
@textbox-disabled-background-color: lighten(@disabled-background-color, 27%);

@textbox-padding: 3px; // Padding for Textbox, Textarea, etc.

// CheckBox, RadioButton
@focus-outline-color: darken(
  @secondary-color,
  65
); // Color for artificial focus outline around labels of checkboxes

// TabContainer
@nestedtab-hovered-background-color: @unfocused-clickable-color;
@nestedtab-hovered-border-color: @primary-color;
@nestedtab-selected-border-color: @selected-border-color;
@nestedtab-selected-background-color: @minor-selected-color;
@tab-disabled-background-color: @disabled-color; // For disabled tabs of a TabContainer (not officially supported)

// Arrow buttons (stand alone, or inside ComboBox / ComboButton / Spinner / etc.
//@arrowbutton-background-color: @secondary-color;
@arrowbutton-background-color: @ct-highlight-color;
@arrowbutton-hovered-background-color: @ct-highlight-color; // Color of arrow when hovering ComboBox.   But hovering Spinner doesn't change arrow color (TODO)
@arrowbutton-pressed-background-color: darken(@ct-highlight-color, 10%);
@arrowbutton-inner-border-color: transparent; // Typically the arrows have an inner white border (a.k.a. padding) and then an outer black-ish border

// Slider
// Note: any changes here require corresponding changes in form/images/sliderThumbs.png
@slider-fullbar-background-color: @ct-highlight-color; // Background color for part of slider bar before (to the left or below) the handle
@slider-remainingbar-background-color: @container-background-color; // Background color for part of slider bar after (to the right or above) the handle
@slider-hovered-fullbar-background-color: @ct-highlight-color; // Background color for part of bar of hovered slider before (to the left or below) the handle
@slider-hovered-remainingbar-background-color: @container-background-color; // Background color for part of bar of hovered slider after (to the right or above) the handle
@slider-hoveredButton-background-color: @ct-highlight-color; // Background color of slider increment/decrement buttons when mouse is over slider but not over the buttons
@slider-focused-fullbar-background-color: @ct-highlight-color; // Background color for part of bar of focused slider before (to the left or below) the handle
@slider-focused-remainingbar-background-color: @container-background-color; // Background color for part of bar of focused slider after (to the right or above) the handle
@slider-button-hovered-background-color: @ct-highlight-color; // Background color of slider increment/decrement buttons when mouse is over the buttons
@slider-button-pressed-background-color: @ct-highlight-color; // Background color of slider increment/decrement buttons while button is depressed

// Select, ComboBox
@select-dropdownitem-background-color: @container-background-color; // Background color for items in the drop down list of a ComboBox/Select
@select-dropdownitem-hovered-background-color: @pressed-background-color; // Background color for the hovered item in the drop down list of a ComboBox/Select
@select-matchedtext-background-color: @minor-selected-color; // Background color of text in ComboBox drop down that matches typed in phrase

// Menus
@menu-background-color: lighten(@pane-background-color, 5%);

// Calendar
@calendar-background-color: @minor-selected-color;
@calendar-currentmonth-background-color: @ct-tooltip-background-color; // Background color for days of the current month
@calendar-adjacentmonth-background-color: @disabled-color; // Background color used for days from previous or next month
@calendar-adjacentmonth-text-color: @disabled-text-color; // Text color used for days from previous or next month
@calendar-date-pressed-border-color: @container-background-color; // For some reason pressing a day of the month (as opposed to hovering it) makes the border go away, is this intentional?
@calendar-date-pressed-background-color: @pressed-background-color;
@calendar-date-selected-border-color: @selected-border-color;
@calendar-date-selected-background-color: @minor-selected-color;
@calendar-button-hovered-background-color: @minor-selected-color; // for hover or next/previous year, and month drop down (TODO: border and background are built in to calendarArrows.png, can't control from here)
@calendar-button-hovered-border-color: darken(
  @hovered-background-color,
  10
); // for hover or next/previous year, and month drop down
@calendar-button-pressed-background-color: @pressed-background-color;
@calendar-button-pressed-border-color: @pressed-border-color;

// ProgressBar
@progressbar-border-color: @popup-border-color; // Border color of progress bar
@progressbar-full-background-color: @minor-selected-color; // Background color for part of progress bar indicating amount completed
@progressbar-empty-background-color: @container-background-color; // Background color for part of progress bar indicating amount remaining
@progressbar-text-color: @text-color; // Color of progress bar text (ex: "35%").  Must contrast with both empty and full background colors.

// TimePicker
@timepicker-minorvalue-background-color: @textbox-background-color; // For 3:15, 3:30, 3:45 but not 3:00 or 4:00
@timepicker-minorvalue-text-color: @text-color;
@timepicker-majorvalue-background-color: @unfocused-clickable-color; // For 3:00, 4:00, 5:00, etc.
@timepicker-value-hovered-background-color: @button-hovered-background-color;
@timepicker-value-hovered-text-color: @hovered-text-color;
@timepicker-arrow-hovered-background-color: @button-hovered-background-color;

// ColorPalette
@colorpalette-background-color: @container-background-color;
@swatch-border-color: @minor-border-color;
@swatch-hovered-border-color: #000;
@swatch-selected-border-color: #000;

// Dialog
@dialog-underlay-color: @container-background-color; // the thing that grays out the screen when a dialog is shown
@dialog-titlebar-border-color: @container-background-color; // Inner border around the title sectionof a Dialog, inside the main border of the Dialog and the border between title and content
@dialog-titlebar-background-color: @ct-highlight-color;

// Tooltip
@tooltip-gradient-color: fade(
  @primary-color,
  10%
); // a little swath of color at the bottom of tooltips

// BorderContainer
@splitter-hovered-background-color: @primary-color; // Color of splitter when user hovers it, before mouse down
@splitter-dragged-background-color: @minor-selected-color; // Color of splitter while it's being dragged

// Toolbar
@toolbar-button-checked-background-color: @container-background-color; // a toggled-on button in the toolbar
@toolbar-combobutton-hovered-unhoveredsection-background-color: spin(
  saturate(darken(@primary-color, 8), 19),
  -29
); // when user hovers a ComboButton in a Toolbar, the other half of the button turns this color
@toolbar-button-border-radius: 0; // Rounded corner radius for buttons for buttons in toolbar

// DnD
@dnd-avatar-background-color: @container-background-color; // Background color of little Dialog-type box indicating dragged items
@dnd-avatar-header-background-color: #f58383; // Title bar for dragged items
@dnd-avatar-candrop-header-background-color: #97e68d; // Title bar for dragged items when they can be dropped
@dnd-dropseparator-color: #369; // Color of line indicating that user is about to drop between items A & B

// Document level
@document-text-color: @text-color; // Text color for document itself (text outside of widgets)
@document-shadedsection-background-color: @bar-background-color; // background color used for <pre>, <code>, and table header rows
@document-border-color: @disabled-color; // Border for <pre>, <code>, tables, etc.

// Icons, arrows, etc.
@image-arrow-sprite: "images/spriteArrows.png";
@image-calendar-arrows: "images/calendarArrows.png";
@image-calendar-arrows-ie6: "images/calendarArrows8bit.png";
@image-checkmark: "images/checkmarkNoBorder.png";
@image-checkmark-ie6: "images/checkmarkNoBorder.gif";
@image-dialog-close: "images/dialogCloseIcon.png";
@image-dialog-close-ie6: "images/dialogCloseIcon8bit.png";
@image-dnd: "images/dnd.png";
@image-editor-icons-enabled: "../../icons/images/editorIconsEnabled.png";
@image-form-button-arrows: "form/images/buttonArrows.png";
@image-form-checkbox-and-radios: "form/images/checkboxRadioButtonStates.png";
@image-form-checkbox-and-radios-ie6: "form/images/checkboxAndRadioButtons_IE6.png";
@image-form-common-arrows: "form/images/commonFormArrows.png";
@image-form-error: "form/images/error.png";
@image-form-slider-thumbs: "form/images/sliderThumbs.png";
@image-layout-tab-close: "layout/images/tabClose.png"; // [x] icon to close a tab
@image-loading-animation: "images/loadingAnimation.gif";
@image-loading-animation-rtl: "images/loadingAnimation_rtl.gif";
@image-tooltip: "images/tooltip.png"; // arrow connectors
@image-tooltip-ie6: "images/tooltip8bit.png"; // arrow connectors (8 bit)
@image-tree-expand: "images/treeExpandImages.png";
@image-tree-expand-ie6: "images/treeExpandImages8bit.png";
@image-progressbar-anim: "images/progressBarAnim.gif";

//---------------------------------------
//---------------------------------------
//---------------------------------------

// additional mixins
@ct-highlight-color: #0065a2; // Highlight Color, should have a high contrast to primary-color

@ct-primary-button-color: @ct-highlight-color; //primary buttons use to create a user-focus for very special UI Elements. Use class "ctPrimaryInput" wisely
@ct-primary-button-text-color: #fff;
@ct-primary-button-hovered-color: lighten(@ct-primary-button-color, 6%);
@ct-primary-button-hovered-text-color: @ct-primary-button-text-color;

@ct-use-font-icons: true;
@ct-warn-color: #f39c12; // a nice color used e.g. as background color for warning messages

@ct-header-background-color: @container-background-color;
@ct-footer-background-color: @container-background-color;

@ct-highlight-text-color: #ffffff;
@ct-highlight-hover-text-color: @ct-highlight-color;
@ct-highlight-border-color: @ct-highlight-color;

@ct-primary-contrast-text-color: @text-color;
@ct-primary-contrast-border-color: #333;
@ct-highlight-contrast-text-color: #ffffff; // color that has a high contrast to the highlight color

@ct-dialog-border-radius: 0; // used for Dialogs and TabContainer Tabs
@ct-dialog-title-text-color: @ct-highlight-text-color; // Text color for the dialog title

@ct-collapse-and-resize-handle-color: @ct-highlight-color; //background-color of Collapsehandles

@ct-tooltip-text-color: #000;
@ct-tooltip-border-color: @secondary-color; // can't be dependend because the tooltip connector is just an image and the tooltip border color needs to match this image ;)
@ct-tooltip-background-color: @primary-color;

@ct-toolset-button-background-color: @primary-color; // used for first toolset Button when Toolset is Collapsed and the WindowTitleBar
@ct-toolset-tool-button-background-color: @primary-color;
@ct-toolset-tool-button-hovered-background-color: @ct-highlight-color; // used for a hovered Toolset ToolButton
@ct-toolset-tool-button-checked-background-color: @ct-primary-button-color; // used for a checked Toolset ToolButton
@ct-shrinking-dropdown-button-background-color: transparent; // used for basemap, theme, template and language toggle buttons

@ct-font-family: "Open Sans", Helvetica, Arial, sans-serif;
@ct-font-family-alternative: Courier, sans-serif;

@ct-textbox-font-color: #fff - @textbox-background-color;
@ct-textbox-edit-background-color: @textbox-background-color; //@container-background-color;			// background color  for inline editing of TextBox based widgets

@ct-text-color: @ct-highlight-color; // Standard link color inside panels

@ct-button-text-color: #fff;
@ct-button-disabled-text-color: lighten(@text-color, 60%);
@ct-button-padding: 2px 12px 4px; // Button Padding
@ct-button-hovered-text-color: #fff;

// colors for ct messagePane
@ct-message-pane-info-color: lighten(
  @selected-background-color,
  25%
); // colors for ct messagePane
@ct-message-pane-loading-color: @ct-message-pane-info-color; // colors for ct messagePane
@ct-message-pane-success-color: #28ae6d; // colors for ct messagePane
@ct-message-pane-warning-color: @ct-warn-color; // colors for ct messagePane
@ct-message-pane-error-color: @error-color;

@ct-tab-text-color: @text-color;
@ct-tab-text-hover-color: @hovered-text-color;
@ct-tab-text-active-color: @hovered-text-color;
@ct-tab-text-disabled-color: lighten(@text-color, 10%);
@ct-tab-text-checked-color: contrast(
  @selected-background-color,
  @ct-highlight-color,
  @text-color
);

// IconSizeConfiguration
@ct-icon-small: 15px;
@ct-icon-medium: 22px;
@ct-icon-large: 30px;

//default icon colors
@ct-icon-color: @ct-highlight-color;
@ct-icon-hovered-color: #111;
//color for muted icons (e.g. LocateMe)
@ct-icon-muted-color: #696c75;
@ct-icon-muted-hovered-color: @ct-highlight-color;
//color for icons, lying above the highlight color:
@ct-icon-on-primary-color: #fff;
@ct-icon-on-primary-hovered-color: #fff;

// (d)Grid Colors
@ct-dGrid-background-color: @container-background-color;
@ct-dGrid-header-background-color: lighten(@ct-highlight-color, 20%);
@ct-dGrid-header-text-color: @ct-highlight-text-color;
@ct-dGrid-hovered-row-color: desaturate(
  lighten(@ct-highlight-color, 10%),
  5%
); //bg color of hovered grid rows
@ct-dGrid-hovered-row-text-color: @ct-highlight-text-color; //text color of hovered grid rows
@ct-dGrid-highlighted-row-color: lighten(
  @ct-icon-muted-hovered-color,
  10%
); //bg color of hover and selected grid rows
@ct-dGrid-highlighted-row-text-color: @ct-highlight-text-color; //text color of selected grid rows
@ct-dGrid-border-color: @ct-dGrid-background-color;
@ct-dGrid-vertical-table-borders: false;
@ct-dGrid-horizontal-table-borders: true;
@ct-dGrid-selected-row-color: lighten(@ct-icon-muted-hovered-color, 10%);
@ct-dGrid-selected-row-text-color: @ct-highlight-text-color;

// Scrollbar Colors (Chrome only)
@ct-scrollbar-track-color: #ffffff;
@ct-scrollbar-thumb-color: darken(@ct-highlight-color, 5%);
@ct-scrollbar-thumb-border-color: #ffffff;

// Width of DropdownTogglers in Top Right
@ct-toggler-width: 85px;
@ct-toggler-height: 30px;
@ct-language-toggler-width: 79px;

// Map Flow Colors
@ct-mapflow-cover-text-color: #000;
@ct-mapflow-cover-border-color: #fff;
@ct-mapflow-selected-cover-border-color: @minor-selected-color;

// Omni Search Colors
@ct-omnisearch-result-list-hover-color: @minor-selected-color;

// Scale Bar Colors
@ct-scalebar-color: lighten(@ct-primary-contrast-text-color, 10%);

// ZoomSlider
@ct-zoomslider-is-animated: true; // if true, the zoomSlider expands on hover an collapses after some time (doesn't work with esriSimpleSlider)

// box shadow settings for UI Elements (Buttons, Tools, Toolsets) onto the map
@ct-standard-box-shadow: 3px 3px 3px rgba(0, 0, 0, 0.1);

// IMPORTANT - DO NOT MOVE TO THE TOP OF THE PAGE
@import "../common/crossBrowserSettings.less";
// Mixins defining gradients (originally defined in dijit variables.less
.standard-gradient (@baseColor, @pathToRoot: "") {
  background-color: @baseColor;
  // Fallback for IE (not used for mapapps)
  // background-image: url("@{pathToRoot}images/standardGradient.png");
  // background-repeat: repeat-x;
  // .linear-gradient (rgba(255,255,255,.2), rgba(0,0,0,.2));
}
.standard-gradient-and-filter (@baseColor) {
  background-color: @baseColor;
  //filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#33ffffff', endColorstr='#38000000',GradientType=0 );
  //background-repeat: repeat-x;
  // .linear-gradient (rgba(255,255,255,.2), rgba(0,0,0,.2));
}
